#!/usr/bin/env python

import pygtk
pygtk.require('2.0')
import gtk,numpy,gobject,pango,locale,math

# Colors and Font
(COLOR_UP,COLOR_DN,COLOR_PL,FONT,FONT_TICK,FONT_CONV) = ('#0000FF','#FF0000','#000000','verdana 8','serif,monospace Heavy 7',"serif 8")
# Some constants
(NIT,POT,H2O,O2,SUN)= range(5)
(ASC,BIO,CAR,FOL,NIA,PYR,THI)=range(7)
HeadersInput = ["Nit","Pot","H20","O2","Sun"]
HeadersVit   = ["Asc","Bio","Car","Fol","Nia","Pyr","Thi"]
HeadersConvos = ["ID","Conversion","Conditions","Status","Void"]
itemColors = [COLOR_DN,COLOR_PL,COLOR_UP]

# Helper function for lambda expressions
def if_else(condition, a, b) :
    if condition : return a
    else         : return b
def if_cond(condition):
    if condition : return True
    else         : return False
def Th(value):
    return max(0,min(value,99.99))
def Ret(value,frm,conv,MAX):
    takeout=min(MAX,frm)
    return Th(round(value+takeout*conv,2))

Convos =(("Lose 10 Pot","always",
            (lambda n,p,w,o,s: if_cond(True)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: if_cond(p>0)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: ((n,Th(p-10),w,o,s),(A,B,C,F,N,P,T))),False),
         ("Lose 10 Nit","always",
            (lambda n,p,w,o,s: if_cond(True)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: if_cond(n>0)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: ((Th(n-10),p,w,o,s),(A,B,C,F,N,P,T))),False),
         ("10 Nit -> 3.3 Asc","H20 > 79",
            (lambda n,p,w,o,s: if_cond(w>79)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: if_cond(n>0)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: ((Th(n-10),p,w,o,s),(Ret(A,n,3.33/10,10),B,C,F,N,P,T))),True),
         ("10 Car -> 5 Asc","O2 < 49",
            (lambda n,p,w,o,s: if_cond(o<49)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: if_cond(C>0)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: ((n,p,w,o,s),(Ret(A,C,5/10,5),B,Th(C-10),F,N,P,T))),True),
        ("10 Fol -> 20 Asc","Sun > 69",
            (lambda n,p,w,o,s: if_cond(s>69)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: if_cond(F>0)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: ((n,p,w,o,s),(Ret(A,F,20/10,10),B,C,Th(F-10),N,P,T))),True),
        ("10 Pot -> 2.5 Bio","Sun < 20",
            (lambda n,p,w,o,s: if_cond(s<20)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: if_cond(p>0)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: ((n,Th(p-10),w,o,s),(A,Ret(B,p,2.5/10,10),C,F,N,P,T))),True),
        ("10 Asc -> 20 Bio","H20 < 29",
            (lambda n,p,w,o,s: if_cond(w<29)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: if_cond(A>0)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: ((n,p,w,o,s),(Th(A-10),Ret(B,A,20/10,10),C,F,N,P,T))),True),
        ("10 Pyr -> 10 Bio","O2 > 89",
            (lambda n,p,w,o,s: if_cond(o>89)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: if_cond(P>0)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: ((n,p,w,o,s),(A,Ret(B,P,1,10),C,F,N,Th(P-10),T))),True),
        ("10 Pot -> 3.3 Car","O2 > 69",
            (lambda n,p,w,o,s: if_cond(w>79)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: if_cond(p>0)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: ((n,Th(p-10),w,o,s),(A,B,Ret(C,p,3.33/10,10),F,N,P,T))),True),
        ("10 Asc -> 10 Car","Sun > 79",
            (lambda n,p,w,o,s: if_cond(s>79)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: if_cond(A>0)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: ((n,p,w,o,s),(Th(A-10),B,Ret(C,A,1,10),F,N,P,T))),True),
        ("10 Thi -> 20 Car","H2O < 39",
            (lambda n,p,w,o,s: if_cond(w<39)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: if_cond(T>0)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: ((n,p,w,o,s),(A,B,Ret(C,T,20/10,10),F,N,P,Th(T-10)))),True),
        ("10 Pot -> 2.5 Fol","Sun > 69",
            (lambda n,p,w,o,s: if_cond(s>69)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: if_cond(p>0)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: ((n,Th(p-10),w,o,s),(A,B,C,Ret(F,p,2.5/10,10),N,P,T))),True),
        ("10 Nia -> 30 Fol","H2O < 59",
            (lambda n,p,w,o,s: if_cond(w<59)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: if_cond(N>0)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: ((n,p,w,o,s),(A,B,C,Ret(F,N,30/10,10),Th(N-10),P,T))),True),
        ("10 Thi -> 20 Fol","O2 < 49",
            (lambda n,p,w,o,s: if_cond(o<49)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: if_cond(T>0)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: ((n,p,w,o,s),(A,B,C,Ret(F,T,20/10,10),N,P,Th(T-10)))),True),
        ("10 Asc -> 20 Nia","Sun < 20",
            (lambda n,p,w,o,s: if_cond(s<20)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: if_cond(A>0)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: ((n,p,w,o,s),(Th(A-10),B,C,F,Ret(N,A,20/10,10),P,T))),True),
        ("10 Pyr -> 5 Nia","H20 > 69",
            (lambda n,p,w,o,s: if_cond(w>69)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: if_cond(P>0)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: ((n,p,w,o,s),(A,B,C,F,Ret(N,P,5/10,10),Th(P-10),T))),True),
        ("10 Thi -> 10 Nia","O2 < 39",
            (lambda n,p,w,o,s: if_cond(o<39)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: if_cond(T>0)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: ((n,p,w,o,s),(A,B,C,F,Ret(N,T,1,10),P,Th(T-10)))),True),
        ("10 Nit -> 3.3 Pyr","H20 < 39",
            (lambda n,p,w,o,s: if_cond(w<39)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: if_cond(N>0)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: ((n,p,w,o,s),(A,B,C,F,Th(N-10),Ret(P,N,3.33/10,10),T))),True),
        ("10 Car -> 10 Pyr","Sun > 59",
            (lambda n,p,w,o,s: if_cond(s>59)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: if_cond(C>0)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: ((n,p,w,o,s),(A,B,Th(C-10),F,N,Ret(P,C,1,10),T))),True),
        ("10 Fol -> 20 Pyr","Oxy > 79",
            (lambda n,p,w,o,s: if_cond(o>79)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: if_cond(F>0)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: ((n,p,w,o,s),(A,B,C,Th(F-10),N,Ret(P,F,20/10,10),T))),True),
        ("10 Asc -> 10 Thi","Sun < 40",
            (lambda n,p,w,o,s: if_cond(s<40)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: if_cond(A>0)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: ((n,p,w,o,s),(Th(A-10),B,C,F,N,P,Ret(T,A,1,10)))),True),
        ("10 Car -> 20 Thi","Oxy < 49",
            (lambda n,p,w,o,s: if_cond(o<49)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: if_cond(C>0)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: ((n,p,w,o,s),(A,B,Th(C-10),F,N,P,Ret(T,C,20/10,10)))),True),
        ("10 Nia -> 5 Thi","H2O < 49",
            (lambda n,p,w,o,s: if_cond(w<49)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: if_cond(N>0)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: ((n,p,w,o,s),(A,B,C,F,Th(N-10),P,Ret(T,N,5/10,10)))),True),
         ("Lose 10 H2O","always",
            (lambda n,p,w,o,s: if_cond(w>0)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: if_cond(w>0)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: ((n,p,Th(w-10),o,s),(A,B,C,F,N,P,T))),False),
         ("Lose 10 O2","always",
            (lambda n,p,w,o,s: if_cond(o>0)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: if_cond(o>0)),
            (lambda n,p,w,o,s,A,B,C,F,N,P,T: ((n,p,w,Th(o-10),s),(A,B,C,F,N,P,T))),False),
)


class ThistleGardenWindow:
    def initGarden(self):
        print "initGarden"
        self.gardenInput = numpy.zeros((41,5),int)
        self.gardenState = numpy.zeros((41,5),float)
        self.gardenState_old = numpy.zeros((41,5),float)
        self.gardenVits  = numpy.zeros((41,7),float)
        self.gardenVits_old  = numpy.zeros((41,7),float)
        # Some Test Data
        self.gardenInput[0,SUN]=33
        #self.gardenInput[15,SUN]=99
        #self.gardenInput[0,H2O]=4
        #self.gardenInput[0,O2]=4
        self.gardenInput[0,NIT]=2
        self.gardenInput[0,H2O]=4
        
    def runGarden(self):
        print "Running garden"
        # Init conditions
        self.stepActions=[]  
        for row in range(41):
            # Add Nit, pot, water, oxy from user
            # Update sun values
            actions = ""
            if row ==0:
                begin_state = map(lambda x: min(99.99,x), numpy.ones(5,float)*50 + self.gardenInput[row]*20)
                begin_state[SUN] = self.gardenInput[0,SUN]
                begin_vits=numpy.zeros(7,float)
            else:
                begin_state = map(lambda x: min(99.99,x), self.gardenState[row-1] + self.gardenInput[row]*20)
                begin_vits  = self.gardenVits[row-1]
                # Calculate Sun
                if self.gardenInput[row,SUN] != 0:
                    begin_state[SUN] = self.gardenInput[row,SUN]
                else:
                    begin_state[SUN] = self.gardenState[row-1,SUN]             
            self.gardenState_old[row]=begin_state
            self.gardenVits_old[row] =begin_vits

            for i in range(len(Convos)):
                conv  = Convos[i]
                # Check void
                if self.lsConversions[i][5]:
                    # check if the conversion is active
                    if conv[2](*begin_state):
                        inputs = numpy.concatenate((begin_state,begin_vits))
                        # check if there is the materials in garden
                        if conv[3](*inputs):
                            actions = actions+"* "+conv[0]+" ["+conv[1]+"]\n"
                            print row,actions
                            (begin_state_t,begin_vits_t) = conv[4](*inputs)
                            begin_state = numpy.array(begin_state_t,float)
                            begin_vits  = numpy.array(begin_vits_t,float)
            self.gardenState[row] =begin_state
            self.gardenVits[row]  =begin_vits
            self.stepActions.append(actions)

    def _getdiffs(self,old_vals,new_vals):
        state_dif = numpy.sign(old_vals - new_vals)
        return numpy.concatenate((new_vals,state_dif))

    def updateSheets(self):
        print "updateSheets"
        for i in range(41):
            for j in range(1,6):
                self.lsGardenInput[i][j] = self.gardenInput[i,j-1]
            for j in range(5):
                self.lsGardenState[i][j] =  self.gardenState_old[i,j]
                pass
            for j in range(5,10):
                #self.lsGardenState[i][j] = itemColors[int(self.gardenState[i,j])+1]
                pass
            for j in range(7):
                self.lsGardenVits[i][j] = self.gardenVits_old[i,j]
            for j in range(7,14):
                #self.lsGardenVits[i][j] = itemColors[int(self.gardenVits[i,j])+1]
                pass
        # updateStatusBar(self):
        costs = numpy.sum(self.gardenInput,0)
        cost_str = " Dung: "+ str(costs[0])+", Saltpeter: "+str(costs[1])+", Water:"+str(costs[2])+", Oxy:"+str(costs[3])
        self.status_bar.remove(self.status_cost,self.status_cost_txt)
        self.status_cost_txt = self.status_bar.push(self.status_cost,cost_str)

    def __init__(self):
        self.menu_items = (
            ( "/_File",         None,         None, 0, "<Branch>" ),
            ( "/File/_New",     "<control>N", self.print_hello, 0, None ),
            ( "/File/_Open",    "<control>O", self.print_hello, 0, None ),
            ( "/File/_Save",    "<control>S", self.print_hello, 0, None ),
            ( "/File/Save _As", None,         None, 0, None ),
            ( "/File/sep1",     None,         None, 0, "<Separator>" ),
            ( "/File/Quit",     "<control>Q", gtk.main_quit, 0, None ),
            ( "/_Options",      None,         None, 0, "<Branch>" ),
            ( "/Options/Test",  None,         None, 0, None ),
            ( "/_Help",         None,         None, 0, "<LastBranch>" ),
            ( "/_Help/About",   None,         None, 0, None ),
            )
        # create a new window
        self.initGarden()
        self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
        self.window.set_title("Thiste Garden simulator")
        self.window.set_size_request(950, 600)
        self.window.connect("delete_event", self.delete_event)
        self.window.connect("destroy", self.destroy)
        self.window.set_border_width(0)

        self.font = pango.FontDescription(FONT)

        # The Inputs
        columns = [gobject.TYPE_INT]+[gobject.TYPE_STRING]*5
        self.lsGardenInput = gtk.ListStore(*columns)
        for i in range(41):
            row=[i]
            for j in range(5):
                if self.gardenInput[i,j] == 0:
                    row.append("")
                else:
                    row.append(self.gardenInput[i,j])
            self.lsGardenInput.append(row)            
        self.tvGardenInput = gtk.TreeView(self.lsGardenInput)
        self.tvGardenInput.set_rules_hint(True)
        self.tvGardenInputSel = self.tvGardenInput.get_selection()

        self.tvColInput = [gtk.TreeViewColumn("Tick")]
        tickColumn = gtk.TreeViewColumn("Tick")
        tickTextRenderer = gtk.CellRendererText()
        tickTextRenderer.set_property('font-desc', pango.FontDescription(FONT_TICK))
        tickTextRenderer.set_properties(alignment=pango.ALIGN_RIGHT, xalign=1.0)
        tickColumn.pack_start(tickTextRenderer,True)
        tickColumn.set_attributes(tickTextRenderer,text=0)
        self.tvGardenInput.append_column(tickColumn)        
        for i in range(5):
            inputColumn = gtk.TreeViewColumn(HeadersInput[i])
            inputTextRenderer = gtk.CellRendererText()
            inputTextRenderer. set_property('alignment', pango.ALIGN_RIGHT)
            inputTextRenderer.set_property('font-desc', pango.FontDescription(FONT))
            inputTextRenderer.set_property('editable', True)
            inputTextRenderer.set_properties(alignment=pango.ALIGN_RIGHT, xalign=1.0)
            inputTextRenderer.connect('edited', self.edited_cb,i+1)
            inputColumn.pack_start(inputTextRenderer,True)
            inputColumn.set_cell_data_func(inputTextRenderer, self.render_input)
            inputColumn.set_attributes(inputTextRenderer,text=i+1)
            self.tvGardenInput.append_column(inputColumn)
        self.tvGardenInput.show_all()
        
        #The State
        columns = [gobject.TYPE_FLOAT]*5 +[gobject.TYPE_STRING]*5 + [gobject.TYPE_FLOAT]*5
        self.lsGardenState = gtk.ListStore(*columns)
        for i in range(41):
            row= self.gardenState[i,0:5].tolist()
            for j in range(5,10):
                row.append(itemColors[1])
            row.extend(numpy.zeros(5,float).tolist())
            self.lsGardenState.append(row)
        self.tvGardenState = gtk.TreeView(self.lsGardenState)
        self.tvGardenState.set_rules_hint(True)
        self.tvGardenStateSel = self.tvGardenState.get_selection()
        stateTextRenderer = gtk.CellRendererText()
        stateTextRenderer.set_properties(alignment=pango.ALIGN_RIGHT, xalign=1.0)
        stateTextRenderer.set_property('font-desc', pango.FontDescription(FONT))
        stateTextRenderer.set_property('foreground-set' , True)
        for i in range(5):
            stateColumn = gtk.TreeViewColumn(HeadersInput[i])
            stateColumn.pack_start(stateTextRenderer,True)
            stateColumn.set_attributes(stateTextRenderer,text=i,foreground=i+5)
            stateColumn.set_cell_data_func(stateTextRenderer, self.render_state)
            self.tvGardenState.append_column(stateColumn)
        self.tvGardenState.show_all()
        
        # The Vitamins
        columns = [gobject.TYPE_FLOAT]*7 +[gobject.TYPE_STRING]*7
        self.lsGardenVits = gtk.ListStore(*columns)
        for i in range(41):
            row= self.gardenVits[i,0:7].tolist()
            for j in range(7,14):
                row.append(itemColors[1])
            self.lsGardenVits.append(row)
        self.tvGardenVits = gtk.TreeView(self.lsGardenVits)
        self.tvGardenVits.set_rules_hint(True)
        self.tvGardenVitsSel = self.tvGardenVits.get_selection()
        VitsTextRenderer = gtk.CellRendererText()
        VitsTextRenderer.set_property('font-desc', pango.FontDescription(FONT))
        VitsTextRenderer.set_property('foreground-set' , True)
        VitsTextRenderer.set_properties(alignment=pango.ALIGN_RIGHT, xalign=1.0)
        for i in range(7):
            VitsColumn = gtk.TreeViewColumn(HeadersVit[i])
            VitsColumn.pack_start(VitsTextRenderer,True)
            VitsColumn.set_attributes(VitsTextRenderer,text=i,foreground=i+7)
            VitsColumn.set_cell_data_func(VitsTextRenderer, self.render_vits)
            self.tvGardenVits.append_column(VitsColumn)
        self.tvGardenVits.show_all()
        
        
        # The conversions
        columns = [gobject.TYPE_INT]+[gobject.TYPE_STRING]*4+[gobject.TYPE_BOOLEAN]
        self.lsConversions = gtk.ListStore(*columns)
        for i in range(len(Convos)):
            conv = Convos[i]
            row = (i,conv[0],conv[1],"Active","red",gtk.FALSE)
            self.lsConversions.append(row)
        self.tvConversions = gtk.TreeView(self.lsConversions)
        self.tvConversions.set_rules_hint(True)

        conversionsTextRenderer = gtk.CellRendererText()
        conversionsTextRenderer.set_property('font-desc', pango.FontDescription(FONT_CONV))
        conversionsTextRenderer.set_property('foreground-set' , True)
        #conversionsTextRenderer.set_property('background-set' , True)

        convCol0 = gtk.TreeViewColumn(HeadersConvos[0],conversionsTextRenderer)
        convCol0.set_attributes(conversionsTextRenderer,text=0,foreground=4)
        self.tvConversions.append_column(convCol0)

        convCol1 = gtk.TreeViewColumn(HeadersConvos[1],conversionsTextRenderer)
        convCol1.set_attributes(conversionsTextRenderer,text=1)
        self.tvConversions.append_column(convCol1)

        convCol2 = gtk.TreeViewColumn(HeadersConvos[2],conversionsTextRenderer)
        convCol2.set_attributes(conversionsTextRenderer,text=2)
        self.tvConversions.append_column(convCol2)

        convCol3 = gtk.TreeViewColumn(HeadersConvos[3],conversionsTextRenderer)
        convCol3.set_attributes(conversionsTextRenderer,text=3)
        self.tvConversions.append_column(convCol3)

        conversionsTextRenderer = gtk.CellRendererToggle()
        conversionsTextRenderer.set_property('activatable', True)
        conversionsTextRenderer.connect( 'toggled', self.OnVoidChange)
        convCol4 = gtk.TreeViewColumn(HeadersConvos[4], conversionsTextRenderer)
        convCol4.set_attributes(conversionsTextRenderer,active=5)
        self.tvConversions.append_column(convCol4)


        
        self.tvConversions.show_all()
                
        hbox_garden = gtk.HBox(False,0)
        garden_sheet1 = gtk.VBox(False,0)
        garden_sheet1_label = gtk.Label("Inputs")
        garden_sheet1_label.modify_font(pango.FontDescription("serif bold 10"))
        garden_sheet1.pack_start(garden_sheet1_label,False,True,0)
        garden_sheet1.pack_start(self.tvGardenInput,True,True,0)
        hbox_garden.pack_start(garden_sheet1,False,False,5)

        garden_sheet2 = gtk.VBox(False,0)
        garden_sheet2_label = gtk.Label("Garden State")
        garden_sheet2_label.modify_font(pango.FontDescription("serif bold 10"))
        garden_sheet2.pack_start(garden_sheet2_label,False,True,0)
        garden_sheet2.pack_start(self.tvGardenState,True,True,0)        
        hbox_garden.pack_start(garden_sheet2,False,False,5)
        
        garden_sheet3 = gtk.VBox(False,0)
        garden_sheet3_label = gtk.Label("Garden Vitamins")
        garden_sheet3_label.modify_font(pango.FontDescription("serif bold 10"))
        garden_sheet3.pack_start(garden_sheet3_label,False,True,0)
        garden_sheet3.pack_start(self.tvGardenVits,True,True,0)        
        hbox_garden.pack_start(garden_sheet3,False,False,5)
        
        
        
        self.scrolled_window = gtk.ScrolledWindow()
        self.scroll_pos = self.scrolled_window.get_vadjustment()
        self.scrolled_window.set_border_width(0)
        self.scrolled_window.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_ALWAYS)
        self.scrolled_window.set_size_request(600,100)
        self.scrolled_window.add_with_viewport(hbox_garden)
        #self.scrolled_window.add_with_viewport(self.layoutTable)
        #self.window.add(self.scrolled_window)
        
        self.status_bar = gtk.Statusbar()
        self.status_cost = self.status_bar.get_context_id("cost")
        self.status_cost_txt = self.status_bar.push(self.status_cost, "EMPTY")
        
        # Tool bar
        self.handlebox = gtk.HandleBox()
        self.toolbar = gtk.Toolbar()
        self.toolbar.set_orientation(gtk.ORIENTATION_HORIZONTAL)
        self.toolbar.set_style(gtk.TOOLBAR_BOTH)
        self.toolbar.set_border_width(5)
        self.handlebox.add(self.toolbar)
        self.tick_widget = self.makeTBAdj(self.toolbar, "Tick","Current Tick",self.onChangeTickNumber,None,40)
        self.toolbar.append_space()
        self.nit_widget = self.makeTBAdj(self.toolbar, "Nit","Dung",self.onChangeInputNumber,NIT)
        self.pot_widget = self.makeTBAdj(self.toolbar, "Pot","Saltpeter",self.onChangeInputNumber,POT)
        self.water_widget = self.makeTBAdj(self.toolbar, "H2O","Water",self.onChangeInputNumber,H2O)
        self.oxy_widget = self.makeTBAdj(self.toolbar, "O2","Oxygen",self.onChangeInputNumber,O2)
        # VBox
        
        labelA = gtk.Label("Conversions")
        alabelB = gtk.Label("Rigth Side BOTTOM")
        
        VBox_main = gtk.VBox(False)
        HBox_main = gtk.HBox()
        VBox_right = gtk.VBox()
        VBox_right.pack_start(gtk.Label("Conversions"),False,True,0)
        conv_scrolled_window = gtk.ScrolledWindow()
        conv_scrolled_window.set_border_width(0)
        conv_scrolled_window.set_policy(gtk.POLICY_NEVER, gtk.POLICY_ALWAYS)
        conv_scrolled_window.add_with_viewport(self.tvConversions)
        
        VBox_right.pack_start(conv_scrolled_window,True,True,0)
        
        self.textExplainBuffer = gtk.TextBuffer()
        self.textExplain = gtk.TextView(self.textExplainBuffer)
        VBox_right.pack_start(gtk.Label("Step Log"),False,True,0)
        VBox_right.pack_start(self.textExplain,True,True,0)
        
        
        VBox_right.pack_start(alabelB,False,True,0)
         
        menubar = self.get_main_menu(self.window)
        VBox_main.pack_start(menubar, False, True, 0)
        VBox_main.pack_start(self.handlebox, False, True, 0)
        VBox_main.pack_start(HBox_main,True,True,0)
        HBox_main.pack_start(self.scrolled_window,False,True,0)
        HBox_main.pack_start(VBox_right,False,True,5)
        VBox_main.pack_end(self.status_bar, False,True, 0)
        self.window.add(VBox_main)
        
        # Synchonize with scrollbar
        # self.tvGardenInput.connect('focus_in_event', self.OnTableFocus, self.scroll_pos)

        
        # Update Numbers
        self.runGarden()
        self.setupSelectionChange_on()
        self.updateSheets()
        self.tvGardenInputSel.select_path(0)        
        self.window.show_all()

    def get_main_menu(self, window):
        accel_group = gtk.AccelGroup()
        item_factory = gtk.ItemFactory(gtk.MenuBar, "<main>", accel_group)
        item_factory.create_items(self.menu_items)
        window.add_accel_group(accel_group)
        self.item_factory = item_factory
        return item_factory.get_widget("<main>")

    # Create signals to synchronize selections
    def setupSelectionChange_on(self):
        print "Activate selection Handler"
        self.cb1 = self.tvGardenInputSel.connect('changed',self.onSelectionChanged)
        self.cb2 = self.tvGardenStateSel.connect('changed',self.onSelectionChanged)
        self.cb3 = self.tvGardenVitsSel.connect('changed',self.onSelectionChanged)
    # Remove the above signals 
    def setupSelectionChange_off(self):
        self.tvGardenInputSel.disconnect(self.cb1)
        self.tvGardenStateSel.disconnect(self.cb2)
        self.tvGardenVitsSel.disconnect(self.cb3)
    # Signal to handle selection change
    def onSelectionChanged(self,selection):
        self.setupSelectionChange_off()
        model, paths = selection.get_selected_rows()
        print "Signal Selection change"
        if paths:
            path = paths[0][0]
            self.tvGardenInputSel.select_path(path)
            self.tvGardenStateSel.select_path(path)
            self.tvGardenVitsSel.select_path(path)
            self.tick_widget.set_value(float(path))
            self.nit_widget.set_value(float(self.gardenInput[int(path),NIT]))
            self.pot_widget.set_value(float(self.gardenInput[int(path),POT]))
            self.water_widget.set_value(float(self.gardenInput[int(path),H2O]))
            self.oxy_widget.set_value(float(self.gardenInput[int(path),O2]))
            # Update explainations
            self.textExplainBuffer.set_text(self.stepActions[int(path)])
        self.setupSelectionChange_on()
        self.UpdateConversions(path)
    
        # http://faq.pygtk.org/index.py?req=show&file=faq10.010.htp
        # Adjust scroll window possition
        adj = self.scroll_pos
        alloc = self.tvGardenInput.get_allocation()
        print "geom",alloc.y,adj.value,adj.page_size
        if alloc.y < adj.value or alloc.y > adj.value + adj.page_size:
            # TODO
            #adj.set_value(min(alloc.y, adj.upper-adj.page_size))
            print "fix at",min(alloc.y, adj.upper-adj.page_size)

    def UpdateConversions(self,path):
        # Upade Convos
        for r in self.lsConversions:
            conv  = Convos[r[0]]
            state = self.gardenState[path,0:5]
            if r[5]:
                if conv[2](*state):
                    vits  = self.gardenVits[path,0:7]
                    inputs = numpy.concatenate((state,vits))
                    if conv[3](*inputs):
                        new_text="active"
                        new_color="blue"
                    else:
                        new_text="possible"
                        new_color="red"
                else:
                    new_text="inactive"
                    new_color="black"
            else:
                new_text =" -- "
                new_color="grey"
            r[3]=new_text
            r[4]=new_color

    def onChangeTickNumber(self,widget,data):
        print "Signal change tick Number"
        self.tvGardenInputSel.select_path(str(int(widget.get_value())))
    def onChangeInputNumber(self,widget,what):
        print "Signal change :",what
        pos = int(self.tick_widget.get_value())
        new_value = int(widget.get_value())
        if new_value != self.gardenInput[pos,what] : 
            self.gardenInput[pos,what]=int(widget.get_value())
            self.runGarden()
            self.updateSheets()
            
    def OnVoidChange(self, cell, path):
        self.lsConversions[path][5] = not self.lsConversions[path][5]
        self.runGarden()
        self.updateSheets()
        self.UpdateConversions(path)
        
    def main(self):
        gtk.main()
    
    def render_state(self, column, cell, model, iter):
        origstr = cell.get_property('text')
        number = locale.atof(origstr)
        if number == 0 :
            sizestr = "-"
        else:
            sizestr = "%2.2f" % number 
        cell.set_property('text', sizestr)
    def render_input(self, column, cell, model, iter):
        origstr = cell.get_property('text')
        number = locale.atof(origstr)
        if number == 0 :
            sizestr = ""
        else:
            sizestr = origstr 
        cell.set_property('text', sizestr)
    def render_vits(self, column, cell, model, iter):
        origstr = cell.get_property('text')
        number = math.floor(locale.atof(origstr))
        number = locale.atof(origstr)
        if number == 0 :
            sizestr = "-"
        else:
            sizestr = "%2.2f" % number
            #sizestr = "%d" % number
        cell.set_property('text', sizestr)

    # Obligatory basic callback
    def print_hello(self, w, data):
        print "Hello, World!"
        
    def makeTBAdj(self,toolbar,text,tooltip,callback=None,callback_data=None,upper_limit=5):
        box = gtk.VBox()
        spin_range = gtk.Adjustment(value=0, lower=0, upper=upper_limit, step_incr=1)
        spin_widget = gtk.SpinButton(adjustment=spin_range)
        spin_widget.connect('value-changed',callback,callback_data)
        box.pack_start(gtk.Label(text))
        box.pack_start(spin_widget)
        #append_element(type, widget, text, tooltip_text, tooltip_private_text, icon, callback, user_data)
        toolbar.append_element(gtk.TOOLBAR_CHILD_WIDGET,box,text,tooltip,"",None,None,None)
        return spin_widget
        
    def delete_event(self, widget, event, data=None):
        return False

    def destroy(self, widget, data=None):
        gtk.main_quit()
        
    def edited_cb(self,cell, path, new_text,col):
        print cell,path
        if col==5:
            max_val=99
        else:
            max_val=5
        if len(new_text)==0:
            new_val=0
        else:
            new_val = float(new_text)
        new_val=min(max_val,new_val)
        if new_val >= 0:
            self.gardenInput[path,col-1]=new_val
            self.runGarden()
            self.updateSheets()
        return

# If the program is run directly or passed as an argument to the python
# interpreter then create a HelloWorld instance and show it
if __name__ == "__main__":
    thistle = ThistleGardenWindow()
    thistle.main()
